/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 * 
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#ifndef CREATE_MISSION_XML_SRC_CREATE_MISSION_XML_H_
#define CREATE_MISSION_XML_SRC_CREATE_MISSION_XML_H_

#include <string>
#include <vector>
#include <moduleBasics/module.h>
#include <moduleBasics/strategySelector.h>

class CreateMissionXML : public Module {
 public:
  CreateMissionXML(const int argc, char *argv[], const std::string &tool_name, const std::string &tool_version);
  ~CreateMissionXML() = default;

  void initialize() override { mission_strategy_.initializeStrategy(); };
  void run() override { mission_strategy_.runStrategy(); };
  void update() override { mission_strategy_.updateStrategy(); };
  void report() override { mission_strategy_.reportStrategy(); };
  void save() override {
    mission_strategy_.saveStrategy();
    rtIO_->saveAndCloseAcXML();
    rtIO_->closeModuleConfig();
  };

 private:
  StrategySelector mission_strategy_;
};

#endif // CREATE_MISSION_XML_SRC_CREATE_MISSION_XML_H_
