/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#include "BwbInitialSizingConfig.h"
#include <algorithm>
#include <aixml/node.h>
#include <standardFiles/functions.h>

/* Methods for reading program settings of config */

void BwbInitialSizingConfig::readProgramSettings(const node& config) {
    wing_loading_user = EndnodeReadOnly<double>("/module_configuration_file/program_settings/blended_wing_body/readonly_approach/wing_loading").read(config).value();
    thrust_loading_user = EndnodeReadOnly<double>("/module_configuration_file/program_settings/blended_wing_body/readonly_approach/thrust_loading").read(config).value();
    maximum_takeoff_mass_user = EndnodeReadOnly<double>(
        "/module_configuration_file/program_settings/blended_wing_body/readonly_approach/maximum_takeoff_mass_start").read(config).value();
    operating_mass_empty_user = EndnodeReadOnly<double>(
        "/module_configuration_file/program_settings/blended_wing_body/readonly_approach/operating_mass_empty_start").read(config).value();
}
