/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 * 
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */
#include "performance_assessment.h"

#include <vector>
#include <map>
#include <memory>

#include "taw/defaultMethods/performance_assessment_factory.h"

performance_assessment::performance_assessment(const int argc, char *argv[], const std::string& toolName, const std::string& toolVersion) : Module(argc, argv, toolName, toolVersion) {
    std::string configuration = rtIO_->aircraft_configuration_type();

    /* Register existing strategies */
    strategy.registerStrategy<taw::performance_assessment_factory>({"tube_and_wing"});
    strategy.setStrategy({configuration}, rtIO_);
}
