# UNICADO - UNIversity Conceptual Aircraft Design and Optimization
#
# Copyright (C) 2025 UNICADO consortium
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <https://www.gnu.org/licenses/>.
#
# Description:
# This file is part of UNICADO.

def calculate_z_position(fuselage_geometry, idx):
    """Calculate z position.

    :param _type_ fuselage_geometry: _description_
    :param _type_ tank_dict: _description_
    :param _type_ idx: _description_
    :param _type_ section_name: _description_, defaults to None
    :return _type_: _description_
    """
    lower_height = -fuselage_geometry['interpolated_lower_heights'][idx]
    height = fuselage_geometry['interpolated_heights'][idx]
    z_origin = fuselage_geometry['interpolated_section_origin_z'][idx]
    z_middle = lower_height + height * 0.5
    if z_middle > z_origin:
        z_position =  abs(z_origin) + z_middle
    elif z_middle < z_origin:
        z_position =  abs(z_origin) - abs(z_middle)
    else:
        z_position =  0.0

    return z_position
