/*
 * UNICADO - UNIversity Conceptual Aircraft Design and Optimization
 *
 * Copyright (C) 2025 UNICADO consortium
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 * Description:
 * This file is part of UNICADO.
 */

#ifndef SPAR_METHODS_H_
#define SPAR_METHODS_H_

#include <iostream>
using modes = std::string;
#include <aircraftGeometry2/geometry/surface.h>

#include "lib/io_methods/sparIO.h"

namespace user_defined {

std::vector<geom2::MultisectionSurface<geom2::PolygonSection>> spars(std::vector<Spar> spar_elements);
}  // namespace user_defined


std::vector<geom2::MultisectionSurface<geom2::PolygonSection>> get_spars(modes spars_mode,
                                                                         std::vector<Spar> spar_elements);

#endif  // SPAR_METHODS_H_


